extern "C" {
#include <display_syscalls.h>
#include <keyboard_syscalls.h>
#include <keyboard.hpp>
#include <color.h>
#include <fxCG_Display.h>
//
void G3A_main(void) {
	int x = 1;
	int y = 1;
	int text_color = TEXT_COLOR_BLACK;
	int text_mode = TEXT_MODE_NORMAL;
	int key;

	// Strings that get printed from PrintXY need two spaces of padding...
	char* heart = "  \xE5\xE2";

	while (1) {
		Bdisp_AllCr_VRAM();
		PrintXY(x, y, heart, text_mode, text_color);
		GetKey(&key);
		switch (key) {
			case KEY_CTRL_UP:
				y = y == 1 ? 8 : y-1;
				break;
			case KEY_CTRL_DOWN:
				y = y == 8 ? 1 : y+1;
				break;
			case KEY_CTRL_LEFT:
				x = x == 1 ? 21 : x-1;
				break;
			case KEY_CTRL_RIGHT:
				x = x == 21 ? x=1 : x+1;
				break;
			case KEY_CHAR_PLUS:
				text_color = text_color == 7 ? 0 : text_color+1;
				break;
			case KEY_CHAR_MINUS:
				text_color = text_color == 0 ? 7 : text_color-1;
				break;
			case KEY_CHAR_MULT:
				text_mode = !text_mode;
				break;
			case KEY_CHAR_DIV:
				text_mode = !text_mode;
				break;
		}
	}

	return;
}

#pragma section _BR_Size
unsigned long BR_Size;
#pragma section

}

